@echo off

REM Adjust path for the below components. Projects, Libraries and Manager Data folders can be assigned to special locations! Major build number can change after updating BIMcloud!
set ManagerDir=F:\The\Installation\Directory\of\BIMcloud\Manager-<installation-date>
set ManagerDataDir=F:\The\Installation\Directory\of\BIMcloud\Manager-<installation-date>\Data
set ServerDir=F:\The\Installation\Directory\of\BIMcloud\Server-<installation-date>
set ProjectDir=F:\The\Installation\Directory\of\BIMcloud\Server-<installation-date>\Projects
set LibraryDir=F:\The\Installation\Directory\of\BIMcloud\Server-<installation-date>\Attachments
set localBkUp=F:\Backup\Folder\Location
set ManagerService=PortalServerService-v24.0(Manager-<installation-date>)
set ServerService=TeamworkApplicationServerMonitor-v24.0(Server-<installation-date>)

REM Editing the script below this line is not necessary!

REM Checking if BIMcloud Basic or the Backup folder does not exist. Creating sub folders in Backup folder.
if not exist "%ManagerDir%" echo Missing installation directory "%ManagerDir%"
if not exist "%ManagerDataDir%" echo Missing installation directory "%ManagerDataDir%"
if not exist "%ServerDir%" echo Missing installation directory "%ServerDir%"
if not exist "%ProjectDir%" echo Missing installation directory "%ProjectDir%"
if not exist "%LibraryDir%" echo Missing installation directory "%LibraryDir%"

if not exist "%localBkup%" echo Missing Backup folder "%localBkup%"

if not exist "%ManagerDir%" goto done
if not exist "%ManagerDataDir%" goto done
if not exist "%ServerDir%" goto done
if not exist "%ProjectDir%" goto done
if not exist "%LibraryDir%" goto done

if not exist "%localBkup%" goto done
if not exist "%localBkUp%\Server" md "%localBkUp%\Server"
if not exist "%localBkUp%\Manager" md "%localBkUp%\Manager"
if not exist "%localBkUp%\Server" goto done
if not exist "%localBkUp%\Manager" goto done

REM Cleaning the backup folder
rd "%localBkUp%\Server\Config" /S /Q  
rd "%localBkUp%\Server\Mailboxes" /S /Q  
rd "%localBkUp%\Server\Sessions" /S /Q  
rd "%localBkUp%\Server\Projects" /S /Q  
rd "%localBkUp%\Server\Attachments" /S /Q  
rd "%localBkUp%\Manager\Data" /S /Q
rd "%localBkUp%\Manager\Config" /S /Q

REM Stopping Server and Manager
call v24StopServerService.bat
call v24StopManagerService.bat

REM Copying the Manager's data
robocopy "%ManagerDataDir%" "%localBkUp%\Manager\Data" /E /Z
robocopy "%ManagerDir%\Config" "%localBkUp%\Manager\Config" /E /Z

REM Restarting Manager service while copying files for Server so it has time to start properly
sc start %ManagerService%

REM Copying the Server's data
robocopy "%ServerDir%\Config" "%localBkUp%\Server\Config" /E /Z
robocopy "%ServerDir%\Mailboxes" "%localBkUp%\Server\Mailboxes" /E /Z
robocopy "%ServerDir%\Sessions" "%localBkUp%\Server\Sessions" /E /Z
robocopy "%ProjectDir%" "%localBkUp%\Server\Projects" /E /Z
robocopy "%LibraryDir%" "%localBkUp%\Server\Attachments" /E /Z

REM Restarting Server service
sc start %ServerService%

:done
